'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Child = function (_Component) {
    _inherits(Child, _Component);

    function Child(props) {
        _classCallCheck(this, Child);

        var _this = _possibleConstructorReturn(this, (Child.__proto__ || Object.getPrototypeOf(Child)).call(this, props));

        _this.state = {
            class: 'child',
            term: ''
        };

        // this.props.onInputChange = this.onInputChange.bind(this)
        return _this;
    }

    _createClass(Child, [{
        key: 'onInputChange',
        value: function onInputChange(event) {
            // console.debug(event.target.value);
            this.setState({ term: event.target.value });
        }
    }, {
        key: 'onFormSubmit',
        value: function onFormSubmit(event) {
            event.preventDefault();

            // this.setState({ term: '' });
            console.debug('CHILD onFormSubmit : ', this.state.term);
        }
    }, {
        key: 'selectButton',
        value: function selectButton(string) {
            console.debug(string);
        }
    }, {
        key: 'html',
        value: function html() {
            return _react2.default.createElement(
                'div',
                { className: 'childHtml' },
                _react2.default.createElement(
                    'form',
                    { onSubmit: this.props.onFormSubmit.bind(this), className: 'input-group' },
                    _react2.default.createElement(
                        'div',
                        null,
                        'CHILD HTML'
                    ),
                    _react2.default.createElement(
                        'div',
                        null,
                        'CHILD CONTENT'
                    ),
                    _react2.default.createElement('input', {
                        placeholder: 'Child input',
                        className: 'form-control',
                        value: this.props.state.term,
                        onChange: this.props.onInputChange.bind(this) }),
                    _react2.default.createElement(
                        'button',
                        { type: 'submit', className: 'btn btn-secondary' },
                        'Submit'
                    )
                )
            );
        }
    }, {
        key: 'renderHtml',
        value: function renderHtml() {
            var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.html();

            return html;
        }

        //{this.props.renderHtml(this.renderHtml())}

    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                { className: this.props.class('CHILD') },
                _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                        'div',
                        null,
                        'FROM PARENT'
                    ),
                    this.props.heading('CHILD HEADING'),
                    this.props.body(),
                    this.props.button()
                ),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                    'div',
                    null,
                    this.props.renderHtml(this.renderHtml())
                ),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                        'div',
                        null,
                        'FROM CHILD'
                    ),
                    _react2.default.createElement(
                        'button',
                        { onClick: function onClick() {
                                return _this2.selectButton('CHILD');
                            } },
                        'CHILD'
                    ),
                    _react2.default.createElement(
                        'button',
                        { onClick: function onClick() {
                                return _this2.props.parentFunction('CHILD');
                            } },
                        'CHILD'
                    )
                )
            );
        }
    }]);

    return Child;
}(_react.Component);

exports.default = Child;