'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _child = require('./child');

var _child2 = _interopRequireDefault(_child);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Parent = function (_Component) {
    _inherits(Parent, _Component);

    function Parent(props) {
        _classCallCheck(this, Parent);

        var _this = _possibleConstructorReturn(this, (Parent.__proto__ || Object.getPrototypeOf(Parent)).call(this, props));

        _this.state = {
            class: 'parent',
            heading: 'PARENT HEADING',
            term: ''
        };

        // this.selectButton = this.selectButton.bind(this);
        // this.renderHtml = this.renderHtml.bind(this);
        // this.html = this.html.bind(this);
        // this.onFormSubmit = this.onFormSubmit.bind(this);
        // this.render = this.render.bind(this);
        return _this;
    }

    _createClass(Parent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            console.debug('PARENT componentDidMount()');
            this.selectButton('string');
        }
    }, {
        key: 'setClassName',
        value: function setClassName() {
            var string = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.class;

            return string;
        }
    }, {
        key: 'heading',
        value: function heading() {
            var string = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.heading;

            return _react2.default.createElement(
                'h3',
                null,
                string
            );
        }
    }, {
        key: 'onInputChange',
        value: function onInputChange(event) {
            this.setState({ term: event.target.value });
        }
    }, {
        key: 'onFormSubmit',
        value: function onFormSubmit(event) {
            event.preventDefault();

            // this.setState({ term: '' });
            console.debug('PARENT onFormSubmit : ', this.state.term);
        }
    }, {
        key: 'html',
        value: function html() {
            return _react2.default.createElement(
                'div',
                { className: 'parentHtml' },
                _react2.default.createElement(
                    'form',
                    { onSubmit: this.onFormSubmit.bind(this), className: 'input-group' },
                    _react2.default.createElement(
                        'div',
                        null,
                        'PARENT HTML'
                    ),
                    _react2.default.createElement(
                        'div',
                        null,
                        'PARENT CONTENT'
                    ),
                    _react2.default.createElement('input', {
                        placeholder: 'Parent input',
                        className: 'form-control',
                        value: this.state.term,
                        onChange: this.onInputChange.bind(this) }),
                    _react2.default.createElement(
                        'button',
                        { type: 'submit', className: 'btn btn-secondary' },
                        'Submit'
                    )
                )
            );
        }
    }, {
        key: 'renderHtml',
        value: function renderHtml() {
            var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.html();

            return html;
        }
    }, {
        key: 'body',
        value: function body(string) {
            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    'div',
                    null,
                    string
                )
            );
        }
    }, {
        key: 'myCustomFunction',
        value: function myCustomFunction() {
            console.debug('myCustomFunction from Parent');
        }
    }, {
        key: 'button',
        value: function button() {
            var _this2 = this;

            return _react2.default.createElement(
                'button',
                { onClick: function onClick() {
                        return _this2.selectButton('PARENT');
                    } },
                'PERANT'
            );
        }
    }, {
        key: 'selectButton',
        value: function selectButton(string) {
            console.debug('parent : ', string);
        }
    }, {
        key: 'parentFunction',
        value: function parentFunction() {
            var string = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'PARENT';

            console.debug(string);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                        'button',
                        { onClick: function onClick() {
                                return _this3.myCustomFunction();
                            } },
                        'select me'
                    )
                ),
                _react2.default.createElement(_child2.default, {
                    'class': function _class(string) {
                        return _this3.setClassName(string);
                    },
                    heading: function heading(string) {
                        return _this3.heading(string);
                    },
                    body: function body() {
                        return _this3.body('body');
                    },
                    button: function button() {
                        return _this3.button();
                    },

                    renderHtml: function renderHtml(html) {
                        return _this3.renderHtml(html);
                    },

                    parentFunction: function parentFunction(string) {
                        return _this3.parentFunction(string);
                    },

                    onInputChange: function onInputChange(string) {
                        return _this3.onInputChange(string);
                    },
                    onFormSubmit: function onFormSubmit(string) {
                        return _this3.onFormSubmit(string);
                    },

                    state: this.state

                })
            );
        }
    }]);

    return Parent;
}(_react.Component);

exports.default = Parent;